/***********************************************
	 Copyright (C) 2015, UNETsystem
 
     seed_cfb.c, SEED, CBC 

	 Creadted by DEV3

************************************************/

#ifndef NO_SEED

#include "../include/seed.h"
#include "../include/typeconvert.h"
/*	
	Name : S_SEED_CBC_Encrypt
	Description: ȣŰ  ʱ⺤͸ ̿Ͽ SEED CBC  ȣ˰ Է ͸ ȣȭ Ѵ
	Parameters
	[in] in : ȣȭ 	
	[in] key : Ű ü	
	[in] bytes : ȣȭ    ̰
	[in] iv : ʱ Ͱ
	[out] out : ȣȭ 
	Return Value : 
	Note : 
*/	
void S_SEED_CBC_Encrypt(U8 *in, U8 *out, SEED_KEY *key, long bytes, U8 *iv)
{
	register U32 tin0, tin1, tin2, tin3;
	register U32 tout0, tout1, tout2, tout3;
	register long l = bytes;
	U8 *ivtemp = iv;
	U32 tin[4];

	U8ToU32(iv, tout0);
	U8ToU32(iv, tout1);
	U8ToU32(iv, tout2);
	U8ToU32(iv, tout3);
	for(l -= 16; l >= 0; l -= 16)
	{
		U8ToU32(in, tin0);
		U8ToU32(in, tin1);
		U8ToU32(in, tin2);
		U8ToU32(in, tin3);
		tin0 ^= tout0; tin[0] = tin0;
		tin1 ^= tout1; tin[1] = tin1;
		tin2 ^= tout2; tin[2] = tin2;
		tin3 ^= tout3; tin[3] = tin3;
		S_SEED_Encrypt(tin, key);
		tout0 = tin[0]; U32ToU8(tout0, out);
		tout1 = tin[1]; U32ToU8(tout1, out);
		tout2 = tin[2]; U32ToU8(tout2, out);
		tout3 = tin[3]; U32ToU8(tout3, out);
	}
	if(l != -16)
	{
		U8ToU32n2(in, tin0, tin1, tin2, tin3, l + 16);
		tin0 ^= tout0; tin[0] = tin0;
		tin1 ^= tout1; tin[1] = tin1;
		tin2 ^= tout2; tin[2] = tin2;
		tin3 ^= tout3; tin[3] = tin3;
		S_SEED_Encrypt(tin, key);
		tout0 = tin[0]; U32ToU8(tout0, out);
		tout1 = tin[1]; U32ToU8(tout1, out);
		tout2 = tin[2]; U32ToU8(tout2, out);
		tout3 = tin[3]; U32ToU8(tout3, out);
	}	
	iv = ivtemp;
	U32ToU8(tout0,iv);
	U32ToU8(tout1,iv);
	U32ToU8(tout2,iv);
	U32ToU8(tout3,iv);
}
/*	
	Name : S_SEED_CBC_Decrypt
	Description: ȣŰ  ʱ⺤͸ ̿Ͽ SEED CBC  ȣ˰ Է ͸ ȣȭ Ѵ
	Parameters
	[in] in : ȣȭ 	
	[in] key : Ű ü	
	[in] bytes : ȣȭ    ̰
	[in] iv : ʱ Ͱ
	[out] out : ȣȭ 
	Return Value : 
	Note : 
*/	
void S_SEED_CBC_Decrypt(U8 *in, U8 *out, SEED_KEY *key, long bytes, U8 *iv)
{
	register U32 tin0, tin1, tin2, tin3;
	register U32 tout0, tout1, tout2, tout3, xor0, xor1, xor2, xor3;
	register long l = bytes;
	U8 *ivtemp = iv;
	U32 tin[4];
	
	U8ToU32(iv, xor0);
	U8ToU32(iv, xor1);
	U8ToU32(iv, xor2);
	U8ToU32(iv, xor3);
	for(l -= 16; l >= 0; l -= 16)
	{
		U8ToU32(in, tin0); tin[0] = tin0;
		U8ToU32(in, tin1); tin[1] = tin1;
		U8ToU32(in, tin2); tin[2] = tin2;
		U8ToU32(in, tin3); tin[3] = tin3;
		S_SEED_Decrypt(tin, key);
		tout0 = tin[0] ^ xor0;
		tout1 = tin[1] ^ xor1;
		tout2 = tin[2] ^ xor2;
		tout3 = tin[3] ^ xor3;
		U32ToU8(tout0, out);
		U32ToU8(tout1, out);
		U32ToU8(tout2, out);
		U32ToU8(tout3, out);
		xor0 = tin0;
		xor1 = tin1;
		xor2 = tin2;
		xor3 = tin3;
	}
	if(l != -16)
	{
		U8ToU32(in, tin0); tin[0] = tin0;
		U8ToU32(in, tin1); tin[1] = tin1;
		U8ToU32(in, tin2); tin[2] = tin2;
		U8ToU32(in, tin3); tin[3] = tin3;
		S_SEED_Decrypt(tin, key);
		tout0 = tin[0] ^ xor0;
		tout1 = tin[1] ^ xor1;
		tout2 = tin[2] ^ xor2;
		tout3 = tin[3] ^ xor3;
		U32ToU8n2(tout0, tout1, tout2, tout3, out, l + 16);
	}
	iv = ivtemp;
	U32ToU8(xor0,iv);
	U32ToU8(xor1,iv);
	U32ToU8(xor2,iv);
	U32ToU8(xor3,iv);
	tin0=tin1=tin2=tin3=0;
	tout0=tout1=tout2=tout3=0;
	xor0=xor1=xor2=xor3=0;
	tin[0]=tin[1]=tin[2]=tin[3]=0;
}

#endif