/***********************************************
	 Copyright (C) 2015, UNETsystem
 
     e_ctr_lea.c  LEA, CTR mode

	 Creadted by DEV3

************************************************/

#ifndef NO_LEA

#include "../include/scrt.h"
#include "../include/lea.h"
#include <string.h>

static int S_lea_ctr128_128_init_key(SCRT_CIPHER_CTX *ctx, U8 *key, U8 *iv, int isenc);
static int S_lea_ctr128_192_init_key(SCRT_CIPHER_CTX *ctx, U8 *key, U8 *iv, int isenc);
static int S_lea_ctr128_256_init_key(SCRT_CIPHER_CTX *ctx, U8 *key, U8 *iv, int isenc);

static void S_lea_ctr128_cipher(SCRT_CIPHER_CTX *ctx, U8 *out, U8 *in, unsigned int inl);

/* ˰ Ư ˸´  structure   */
static SCRT_CIPHER d_ctr128_128_lea=
{
	NID_lea_128_ctr128, /* nid */
	1,  /* block length */
	16, /* key length */
	16, /* iv length */
	S_lea_ctr128_128_init_key, /* iv, key setting Լ */
	S_lea_ctr128_cipher,   /* Ϻȣȭ Լ */
	NULL,				   /*  Լ */
	sizeof(SCRT_CIPHER_CTX)-sizeof((((SCRT_CIPHER_CTX *)NULL)->c))+ /* structure size */
		sizeof((((SCRT_CIPHER_CTX *)NULL)->c.lea_ks))
};

/* LEA 192bit CTR  ˰ Ư ˸´  structure   */
static SCRT_CIPHER d_ctr128_192_lea=
{
	NID_lea_192_ctr128, /* nid */
	1,  /* block length */
	24, /* key length */
	16,  /* iv length */
	S_lea_ctr128_192_init_key, /* iv, key setting Լ */
	S_lea_ctr128_cipher,   /* Ϻȣȭ Լ */
	NULL,				   /*  Լ */
	sizeof(SCRT_CIPHER_CTX)-sizeof((((SCRT_CIPHER_CTX *)NULL)->c))+ /* structure size */
		sizeof((((SCRT_CIPHER_CTX *)NULL)->c.lea_ks))
};

/* LEA 256bit CTR  ˰ Ư ˸´  structure   */
static SCRT_CIPHER d_ctr128_256_lea=
{
	NID_lea_256_ctr128, /* nid */
	1,  /* block length */
	32, /* key length */
	16,  /* iv length */
	S_lea_ctr128_256_init_key, /* iv, key setting Լ */
	S_lea_ctr128_cipher,   /* Ϻȣȭ Լ */
	NULL,				   /*  Լ */
	sizeof(SCRT_CIPHER_CTX)-sizeof((((SCRT_CIPHER_CTX *)NULL)->c))+ /* structure size */
		sizeof((((SCRT_CIPHER_CTX *)NULL)->c.lea_ks))
};

/* structure return ϴ Լ */
/*	
	Name : SCRT_lea_128_ctr128
	Description: LEA 128bit CTR  ȣ˰ ϱ    ü ȯѴ
	Parameters
	Return Value : d_ctr128_128_lea ü ȯѴ
	Note :
*/
SCRT_CIPHER *SCRT_lea_128_ctr128(void)
{
	return(&d_ctr128_128_lea);
}

/*	
	Name : SCRT_lea_192_ctr128
	Description: LEA 192bit CTR  ȣ˰ ϱ    ü ȯѴ
	Parameters
	Return Value : d_ctr128_192_lea ü ȯѴ
	Note :
*/
SCRT_CIPHER *SCRT_lea_192_ctr128(void)
{
	return(&d_ctr128_192_lea);
}

/*	
	Name : SCRT_lea_256_ctr128
	Description: LEA 256bit CTR  ȣ˰ ϱ    ü ȯѴ
	Parameters
	Return Value : d_ctr128_256_lea ü ȯѴ
	Note :
*/
SCRT_CIPHER *SCRT_lea_256_ctr128(void)
{
	return(&d_ctr128_256_lea);
}

/*	
	Name : S_lea_ctr128_128_init_key
	Description: ȣŰ  ī͸ ̿Ͽ LEA 128bit CTR  ȣ˰ ʿ Ű ü  ˰  Ѵ
	Parameters
	[out] ctx : LEA /ȣȭ  LEA_KEY_ST Ű ü    ü
	[in] key : ȣŰ 
	[in] iv : ʱ⺤
	[in] isenc : /ȣȭ  FLAG ( 1 : ȣȭ , ׿ : ȣȭ )
	Return Value : Ͽ  1, ׿  0  ȯѴ
	Note :
*/
static int S_lea_ctr128_128_init_key(SCRT_CIPHER_CTX *ctx, U8 *key, U8 *iv, int isenc)
{
	int ret ;
	if (iv != NULL)
		memcpy(&(ctx->oiv[0]),iv,16);

	memcpy(&(ctx->iv[0]),&(ctx->oiv[0]),16);  /* iv setting */

	if (isenc == 1)
		ret = S_LEA_Keyschedule(&(ctx->c.lea_ks), key, 16);
		//ret = S_ARIA_Encrypt_KeySchedule(&(ctx->c.lea_ks), key, 128);
	else
		ret = S_LEA_Keyschedule(&(ctx->c.lea_ks), key, 16);
		//ret = S_ARIA_Encrypt_KeySchedule(&(ctx->c.lea_ks), key, 128);
	
	if (ret < 0) return 0;
	
	return 1;
}

/*	
	Name : S_lea_ctr128_192_init_key
	Description: ȣŰ  ī͸ ̿Ͽ ARIA 192bit CTR  ȣ˰ ʿ Ű ü  ˰  Ѵ
	Parameters
	[out] ctx : LEA /ȣȭ  LEA_KEY_ST Ű ü    ü
	[in] key : ȣŰ 
	[in] iv : ʱ⺤
	[in] isenc : /ȣȭ  FLAG ( 1 : ȣȭ , ׿ : ȣȭ )
	Return Value : Ͽ  1, ׿  0  ȯѴ
	Note :
*/
static int S_lea_ctr128_192_init_key(SCRT_CIPHER_CTX *ctx, U8 *key, U8 *iv, int isenc)
{
	int ret ;
	if (iv != NULL)
		memcpy(&(ctx->oiv[0]),iv,16);

	memcpy(&(ctx->iv[0]),&(ctx->oiv[0]),16);  /* iv setting */

	if (isenc == 1)
		ret = S_LEA_Keyschedule(&(ctx->c.lea_ks), key, 24);
		//ret = S_ARIA_Encrypt_KeySchedule(&(ctx->c.lea_ks), key, 192);
	else
		ret = S_LEA_Keyschedule(&(ctx->c.lea_ks), key, 24);
		//ret = S_ARIA_Encrypt_KeySchedule(&(ctx->c.lea_ks), key, 192);
	
	if (ret < 0) return 0;
	
	return 1;
}

/*	
	Name : S_lea_ctr128_256_init_key
	Description: ȣŰ  ī͸ ̿Ͽ ARIA 256bit CTR  ȣ˰ ʿ Ű ü  ˰  Ѵ
	Parameters
	[out] ctx : LEA /ȣȭ  LEA_KEY_ST Ű ü    ü
	[in] key : ȣŰ 
	[in] iv : ʱ⺤
	[in] isenc : /ȣȭ  FLAG ( 1 : ȣȭ , ׿ : ȣȭ )
	Return Value : Ͽ  1, ׿  0  ȯѴ
	Note :
*/
static int S_lea_ctr128_256_init_key(SCRT_CIPHER_CTX *ctx, U8 *key, U8 *iv, int isenc)
{
	int ret ;
	if (iv != NULL)
		memcpy(&(ctx->oiv[0]),iv,16);

	memcpy(&(ctx->iv[0]),&(ctx->oiv[0]),16);  /* iv setting */

	if (isenc == 1)
		ret = S_LEA_Keyschedule(&(ctx->c.lea_ks), key, 32);
		//ret = S_ARIA_Encrypt_KeySchedule(&(ctx->c.lea_ks), key, 256);
	else
		ret = S_LEA_Keyschedule(&(ctx->c.lea_ks), key, 32);
		//ret = S_ARIA_Encrypt_KeySchedule(&(ctx->c.lea_ks), key, 256);
	
	if (ret < 0) return 0;
	
	return 1;
}

/*	
	Name : S_lea_ctr128_cipher
	Description: ȣŰ  ʱ⺤͸ ̿Ͽ ARIA CTR  ȣ˰ ̿Ͽ Է/ȣȭ ͸ /ȣȭ Ѵ
	Parameters
	[in] ctx : LEA /ȣȭ  LEA_KEY_ST Ű ü    ü
	[out] out : /ȣȭ  
	[in] in : /ȣȭ  
	[in] inl : /ȣȭ   
	Return Value : 
	Note :
*/
static void S_lea_ctr128_cipher(SCRT_CIPHER_CTX *ctx, U8 *out, U8 *in, unsigned int inl)
{
	int num = 0;
	U8 ecount_buf[/*LEA_BLOCK_SIZE*/ 16];
	memset(ecount_buf, 0 , /*LEA_BLOCK_SIZE*/ 16);

	if (ctx->encrypt)
		S_LEA_CTR128_Encrypt(&(ctx->c.lea_ks), (U8 *)&(ctx->iv), in, inl, out);
		//S_ARIA_CTR128_Encrypt(&(ctx->c.lea_ks), (U8 *)&(ctx->iv), in, inl, out, ecount_buf, &num);
	else
		S_LEA_CTR128_Decrypt(&(ctx->c.lea_ks), (U8 *)&(ctx->iv), in, inl, out);
		//S_ARIA_CTR128_Decrypt(&(ctx->c.lea_ks), (U8 *)&(ctx->iv), in, inl, out, ecount_buf, &num);
}
#endif
